/*
   Folia
   Copyright (C) 2006 Michal Vaner (michal.vaner@kdemail.net)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   he Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef DRAW_WIN_H
#define DRAW_WIN_H

#include <QWidget>
#include <QPixmap>
#include <QRegion>
#include <QColor>
#include <QPoint>

class QTimer;
class QMenu;

class DrawWin : public QWidget {
	Q_OBJECT;
	private:
		QPixmap draw;
		QPixmap color;
		QPixmap label;
		QPixmap screen;
		QColor actColor;
		QRegion mask;
		QMenu *menu;
		QTimer *timer;
		QTimer *screenTimer;
		QPoint lastPos;
		void activ();
		bool activated;
		Qt::MouseButtons buts;
	protected:
		void paintEvent( QPaintEvent *event );
		void mousePressEvent( QMouseEvent *event );
		void mouseReleaseEvent( QMouseEvent *event );
	private slots:
		inline void constructMask();
		inline void updateScreen();
		inline void setColor( const QColor &color );
		inline void clearDraw();
		inline void save();
		inline void load();
		inline void doDraw();
	public:
		DrawWin();
};

#endif
